#ifndef __WIN_MAP_H__
#define __WIN_MAP_H__

#include "win_img.h"
#include "setscrollbar_img.h"

#define CLASS_MAP 			"CLASS_MAP" // |bvAbvEBhẼNX
#define MAP_WIDTH 			320 		// n}̕
#define MAP_HEIGHT 			240 		// n}̍
#define CHIP_SIZE			32			// `bv̕ƍigl 32 ̂݁j
#define SCENE_NPC_MAX		256 		// ʂNPCő吔
#define SCENE_TREASURE_MAX	256 		// ʂ̕󔠍ő吔
#define PWM_CLICKMAP1		WM_APP + 10	// 摜NbNꂽ̃bZ[WiLzuj

#define BYTE_MASK_BG		0x000000FF
#define BYTE_MASK_FLG		0x0000FF00
#define BYTE_MASK_LYER		0x00FF0000
#define BYTE_MASK_UNDEF 	0xFF000000
#define BYTE_MASK_HIT		0x00000F00
#define BYTE_MASK_PRI		0x0000F000

#define BIT_MASK_HIT16_0	0x00000100
#define BIT_MASK_HIT16_1	0x00000200
#define BIT_MASK_HIT16_2	0x00000400
#define BIT_MASK_HIT16_3	0x00000800
#define BIT_MASK_PRI16_0	0x00001000
#define BIT_MASK_PRI16_1	0x00002000
#define BIT_MASK_PRI16_2	0x00004000
#define BIT_MASK_PRI16_3	0x00008000

#define BYTE_SHIFT_BG		0
#define BYTE_SHIFT_FLG		8
#define BYTE_SHIFT_LYER 	16
#define BYTE_SHIFT_UNDEF	24
#define BYTE_SHIFT_HIT		8
#define BYTE_SHIFT_PRI		12

typedef struct{
	int		flag_alpha;		// `tOi0:s, 1:Z, 2:x񂠂j
	BOOL	flag_colorkey;	// J[L[tOi0:ȂA1:, xύXj
	COLOR	colorkey;		// J[L[
	char	name[MAX_PATH];	// 摜t@C
}IMGINF,*LPIMGINF;

typedef struct{
	bool	flagShow;		// ړ͈͕\tOifalse:\Atrue:\j
	int		yMargin;		// YW̒l
	int		idxDir; 		// i0:, 1:, 2:E, 3:j
	POINT	posView;		// r[ʒu
	POINT	posChara;		// r[ʒu
	POINT	posCenter;		// ړ\͈͂̒Sʒu
	POINT	areaMove;		// ړ\͈͂ƂȂ posCenter ̑΋
}POSCHARA,*LPPOSCHARA;

typedef struct{
	int		index;	// ݑIĂ鍀ڔԍ
	POINT	pos;	// \ʒu
	DWORD	width;	// 
	DWORD	height;	// 
	HBITMAP	hBmp;	// DIB nh
}IMGPOS,*LPIMGPOS;

typedef struct{
	int		img_num;			// img 
	IMGPOS	img[SCENE_NPC_MAX];	// NPC 摜
}IMGNPC,*LPIMGNPC;

typedef struct{
	int		img_num;					// img 
	IMGPOS	img[SCENE_TREASURE_MAX];	// 󔠉摜
}IMGTRE,*LPIMGTRE;

HWND	g_hMap = NULL;	// EBhEnh

DWORD	g_dwStyleMap = WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME;

int gMapSizeX	= 0;		// `bv/}bvij
int gMapSizeY	= 0;		// `bv/}bvicj
unsigned long	*gMapData = NULL;		// }bvf[^
IMG				g_map[2] = {NULL};		// }bv`bṽrbg}bvnhƃTCYi0:}bv`bvA1:C[`bvj
IMGNPC			g_imgNPC = {NULL};		// NPC 摜
IMGTRE			g_imgTre = {NULL};		// 󔠉摜
IMGINF			g_lyinf = {NULL};		// C[`bv
RECT			g_rcMap = {0};			// \p`iLzuj
POINT			g_ptMapPre = {-1, -1};	// ȑŐ`ʒuiLzuj
POSCHARA		g_posMap = {0}; 		// Lʒu
int				g_idxNPC = -1;			// ݑIĂLԍ
int				g_idxTre = -1;			// ݑIĂ󔠔ԍ

HWND	g_hDlgPos = NULL;

LRESULT CALLBACK ProcMap(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void M_PaintMap(HDC hDC, int nWidth, int nHeight);
void M_MouseMoveMap(HWND hWnd, LPARAM lParam);
void Draw_RectColor(HDC hDC, RECT rc, int size, COLORREF rgb);
void CreateMapWindow(HWND hParent);
void Resize_MapWin(HWND hDlg);
bool Load_MapData_Bin(char *filename);
void Load_Mapchip(char *filename, int index);
HBITMAP Load_Charachip(char *filename, int x, int y, int width, int height, int flag_alpha, bool flag_colorkey, COLOR colorkey);

// 摜\pEBhẼvV[W
LRESULT CALLBACK ProcMap(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static int	wdh = 0; // NCAg̈̕
	static int	hgt = 0; // NCAg̈̍
	
	switch (uMsg)
	{
	case WM_CREATE:
		g_hMap = hWnd;
		Set_ScrollBar(hWnd);
		return 0;
	case WM_SHOWWINDOW:
		Set_Scroll_nMax(hWnd, gMapSizeX * CHIP_SIZE, gMapSizeY * CHIP_SIZE);
		return 0;
	case WM_SIZE:
		{
			wdh = LOWORD(lParam);
			hgt = HIWORD(lParam);
			Set_Scroll_nPage(hWnd);
			InvalidateRect(hWnd, NULL, FALSE);
		}
		return 0;
	case WM_HSCROLL:
		 Move_Scroll_H(hWnd, wParam);
		return 0;
	case WM_VSCROLL:
		 Move_Scroll_V(hWnd, wParam);
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd, &ps);
			M_PaintMap(hDC, wdh, hgt);
			EndPaint(hWnd, &ps);
		}
		return 0;
	case WM_MOUSEMOVE:
		M_MouseMoveMap(hWnd, lParam);
		return 0;
	case WM_NCMOUSEMOVE:
		if(g_idxOpe == 14 || g_idxOpe == 18){	// Lzu or 󔠔zȕꍇ
			if(g_ptMapPre.x >= 0 || g_ptMapPre.y >= 0){
				g_ptMapPre.x = g_ptMapPre.y = -1;
				InvalidateRect(hWnd, NULL, FALSE);
				SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM) "");
			}
		}
		return 0;
	case WM_LBUTTONDOWN:
		if(g_idxOpe == 14 || g_idxOpe == 18){	// Lzu or 󔠔zȕꍇ
			if(IsWindow(g_hDlgPos)){
				int		x,y;
				char	strCoord[64];
				SendMessage(g_hMap, WM_GETTEXT, sizeof(strCoord), (LPARAM) strCoord);
				sscanf(strCoord, "%d %d", &x, &y);
				DWORD val = (WORD) x | (y << 16);
				SendMessage(g_hDlgPos, PWM_CLICKMAP1, 0, val);
				g_ptMapPre.x = g_ptMapPre.y = -1;
			}
		}
		return 0;
	case WM_CLOSE:
		g_ptMapPre.x = -1;
		g_ptMapPre.y = -1;
		DestroyWindow(hWnd);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcMap

// `iWM_PAINTj ̏
// nWidth	: [IN] EBhE̕
// nHeight	: [IN] EBhE̍
void M_PaintMap(HDC hDC, int nWidth, int nHeight)
{
	HDC 	hDCcp1,hDCcp2;
	HBITMAP hBmpPre1,hBmpPre2;
	BLENDFUNCTION bf;
	bf.BlendOp = AC_SRC_OVER;
	bf.BlendFlags = 0;
	bf.SourceConstantAlpha = 255;
	bf.AlphaFormat = AC_SRC_NO_PREMULT_ALPHA;
	DELGDI(g_hBmpWork);
	g_hBmpWork = Create_New_Dib((PVOID *) &g_pBitsWork, nWidth, nHeight, COLOR_BITW);
	if(g_hBmpWork){
		hDCcp1 = CreateCompatibleDC(hDC);
		hBmpPre1 = (HBITMAP) SelectObject(hDCcp1, g_hBmpWork);
		RECT rc = {0, 0, nWidth, nHeight};
		HRGN hrgn = CreateRectRgnIndirect(&rc);
		SelectClipRgn(hDCcp1, hrgn);
		DeleteObject(hrgn);
		
		int map_left   = scr_x / CHIP_SIZE;
		int map_right  = map_left + si_h.nPage / CHIP_SIZE + 1;
		int map_top    = scr_y / CHIP_SIZE;
		int map_bottom = map_top + si_v.nPage / CHIP_SIZE + 1;
		
		if(scr_x % CHIP_SIZE)
			map_right ++;
		if(scr_y % CHIP_SIZE)
			map_bottom ++;
		if(map_right  > gMapSizeX)
			map_right  = gMapSizeX;
		if(map_bottom > gMapSizeY)
			map_bottom = gMapSizeY;
		
		int i,x,y,idx,dx,dy;
		for(i=0; i<2; i++){
			if(g_map[i].hBmp){
				hDCcp2 = CreateCompatibleDC(NULL);
				hBmpPre2 = (HBITMAP)SelectObject(hDCcp2, g_map[i].hBmp);
				for(y=map_top; y<map_bottom; y++){
					for(x=map_left; x<map_right; x++){
						int pos = y * gMapSizeX + x;
						if(!i)
							idx = gMapData[pos] & BYTE_MASK_BG;
						else
							idx = (gMapData[pos] & BYTE_MASK_LYER) >> BYTE_SHIFT_LYER;
						if(idx > 0){
							int chip_num_x = g_map[i].width / CHIP_SIZE;
							dx = (idx % chip_num_x) * CHIP_SIZE;
							dy = (idx / chip_num_x) * CHIP_SIZE;
							int dst_x = x * CHIP_SIZE - scr_x;
							int dst_y = y * CHIP_SIZE - scr_y;
							int dst_width = CHIP_SIZE;
							int dst_height = CHIP_SIZE;
							if(!i){
								BitBlt(hDCcp1, dst_x, dst_y, dst_width, dst_height,
										hDCcp2, dx, dy, SRCCOPY);
							}
							else{
								if(g_lyinf.flag_alpha == 2)
									AlphaBlend(hDCcp1, dst_x, dst_y, dst_width, dst_height,
												hDCcp2, dx, dy, CHIP_SIZE, CHIP_SIZE, bf);
								else if(g_lyinf.flag_colorkey)
									TransparentBlt(hDCcp1, dst_x, dst_y, dst_width, dst_height,
													hDCcp2, dx, dy, CHIP_SIZE, CHIP_SIZE,
													RGB(g_lyinf.colorkey.red,
														g_lyinf.colorkey.green,
														g_lyinf.colorkey.blue));
								else
									BitBlt(hDCcp1, dst_x, dst_y, dst_width, dst_height,
											hDCcp2, dx, dy, SRCCOPY);
							}
						}
					}
				}
				SelectObject(hDCcp2, hBmpPre2);
				DeleteDC(hDCcp2);
			}
		}
		if(g_idxOpe == 10 || g_idxOpe == 14 || g_idxOpe == 18){	// ʐݒQ or Lzu or 󔠔zȕꍇ
			Draw_Square(hDCcp1, map_left * CHIP_SIZE - scr_x, map_top * CHIP_SIZE - scr_y, map_right * CHIP_SIZE, map_bottom * CHIP_SIZE, CHIP_SIZE, CHIP_SIZE);
		}
		if(g_idxOpe == 14 || g_idxOpe == 18){	// Lzu or 󔠔zȕꍇ
			// ݑIĂȂL or 
			int i;
			for(i=0; i<g_imgNPC.img_num; i++){
				if(g_imgNPC.img[i].hBmp && g_imgNPC.img[i].index != g_idxNPC){
					HDC 	hDCcp3;
					HBITMAP hBmpPre3;
					hDCcp3 = CreateCompatibleDC(NULL);
					hBmpPre3 = (HBITMAP)SelectObject(hDCcp3, g_imgNPC.img[i].hBmp);
					AlphaBlend(hDCcp1, g_imgNPC.img[i].pos.x - scr_x, g_imgNPC.img[i].pos.y - scr_y, g_imgNPC.img[i].width, g_imgNPC.img[i].height, hDCcp3, 0, 0, g_imgNPC.img[i].width, g_imgNPC.img[i].height, bf);
					SelectObject(hDCcp3, hBmpPre3);
					DeleteDC(hDCcp3);
				}
			}
			for(i=0; i<g_imgTre.img_num; i++){
				if(g_imgTre.img[i].hBmp && g_imgTre.img[i].index != g_idxTre){
					HDC 	hDCcp3;
					HBITMAP hBmpPre3;
					hDCcp3 = CreateCompatibleDC(NULL);
					hBmpPre3 = (HBITMAP)SelectObject(hDCcp3, g_imgTre.img[i].hBmp);
					AlphaBlend(hDCcp1, g_imgTre.img[i].pos.x - scr_x, g_imgTre.img[i].pos.y - scr_y, g_imgTre.img[i].width, g_imgTre.img[i].height, hDCcp3, 0, 0, g_imgTre.img[i].width, g_imgTre.img[i].height, bf);
					SelectObject(hDCcp3, hBmpPre3);
					DeleteDC(hDCcp3);
				}
			}
			// ݑIĂL or 
			if(g_img.hBmp){
				HDC 	hDCcp3;
				HBITMAP hBmpPre3;
				hDCcp3 = CreateCompatibleDC(NULL);
				hBmpPre3 = (HBITMAP)SelectObject(hDCcp3, g_img.hBmp);
				POINT ptDst = {(g_posMap.posView.x + g_posMap.posChara.x) * CHIP_SIZE - scr_x, (g_posMap.posView.y + g_posMap.posChara.y) * CHIP_SIZE - g_posMap.yMargin - scr_y};
				POINT ptSize,ptLoad;
				if(g_idxOpe == 14){
					ptSize.x = g_animS.widthLoad / 3;
					ptSize.y = g_animS.heightLoad / 4;
					ptLoad.x = g_animS.ptLoad.x + ptSize.x;
					ptLoad.y = g_animS.ptLoad.y + ptSize.y * (g_posMap.idxDir % 4);
				}
				else if(g_idxOpe == 18){
					ptSize.x = g_animS.width;
					ptSize.y = g_animS.height;
					ptLoad.x = g_animS.ptLoad.x;
					ptLoad.y = g_animS.ptLoad.y;
				}
				if(g_animS.flag_alpha == 2){
					AlphaBlend(hDCcp1, ptDst.x, ptDst.y, ptSize.x, ptSize.y, hDCcp3, ptLoad.x, ptLoad.y, ptSize.x, ptSize.y, bf);
				}
				else if(!g_animS.flag_colorkey){
					BitBlt(hDCcp1, ptDst.x, ptDst.y, ptSize.x, ptSize.y, hDCcp3, ptLoad.x, ptLoad.y, SRCCOPY);
				}
				else{
					COLORREF rgb = RGB(g_animS.colorkey.red, g_animS.colorkey.green, g_animS.colorkey.blue);
					TransparentBlt(hDCcp1, ptDst.x, ptDst.y, ptSize.x, ptSize.y, hDCcp3, ptLoad.x, ptLoad.y, ptSize.x, ptSize.y, rgb);
				}
				SelectObject(hDCcp3, hBmpPre3);
				DeleteDC(hDCcp3);
				// Ԙg
				RECT rcRed = {ptDst.x, ptDst.y, ptDst.x + ptSize.x, ptDst.y + ptSize.y};
				Draw_RectColor(hDCcp1, rcRed, 2, RGB(255,0,0));
				// mobړ͈
				if(g_idxOpe == 14){	// Lzu
					if(g_posMap.flagShow && g_posMap.areaMove.x > 0 && g_posMap.areaMove.y > 0){
						RECT rcMove = {	(g_posMap.posCenter.x - g_posMap.areaMove.x) * CHIP_SIZE - scr_x,
										(g_posMap.posCenter.y - g_posMap.areaMove.y) * CHIP_SIZE - scr_y,
										(g_posMap.posCenter.x + g_posMap.areaMove.x + 1) * CHIP_SIZE - scr_x,
										(g_posMap.posCenter.y + g_posMap.areaMove.y + 1) * CHIP_SIZE - scr_y};
						InvertRect(hDCcp1, &rcMove);
					}
				}
			}
			// |C^ʒu
			if(g_ptMapPre.x >= 0 || g_ptMapPre.y >= 0){
				InvertRect(hDCcp1, &g_rcMap);
			}
		}
		BitBlt(hDC, 0, 0, nWidth, nHeight, hDCcp1, 0, 0, SRCCOPY);
		SelectObject(hDCcp1, hBmpPre1);
		SelectClipRgn(hDCcp1, (HRGN) NULL);
		DeleteDC(hDCcp1);
		DELGDI(g_hBmpWork);
	}
}// M_PaintMap

// }EXړiWM_MOUSEMOVEj
void M_MouseMoveMap(HWND hWnd, LPARAM lParam)
{
	if(g_idxOpe == 14 || g_idxOpe == 18){	// Lzu or 󔠔zȕꍇ
		int xPos = LOWORD(lParam);
		int yPos = HIWORD(lParam);
		POINT pt,pt_surp;
		pt_surp.x = scr_x % CHIP_SIZE;
		pt_surp.y = scr_y % CHIP_SIZE;
		pt.x = (xPos + pt_surp.x) / CHIP_SIZE;
		pt.y = (yPos + pt_surp.y) / CHIP_SIZE;
		if(pt.x != g_ptMapPre.x || pt.y != g_ptMapPre.y){
			SetRect(&g_rcMap, CHIP_SIZE * pt.x - pt_surp.x,
								CHIP_SIZE * pt.y - pt_surp.y,
								CHIP_SIZE * pt.x + CHIP_SIZE - pt_surp.x,
								CHIP_SIZE * pt.y + CHIP_SIZE - pt_surp.y);
			InvalidateRect(hWnd, NULL, FALSE);
			char strCoord[64];
			sprintf(strCoord, "%d %d", pt.x + scr_x / CHIP_SIZE, pt.y + scr_y / CHIP_SIZE);
			SendMessage(g_hMap, WM_SETTEXT, 0, (LPARAM) strCoord);
			g_ptMapPre = pt;
		}
	}
}// M_MouseMoveMap

// `̕`
void Draw_RectColor(HDC hDC, RECT rc, int size, COLORREF rgb)
{
	HPEN	hpen,hpenOld;
	HBRUSH	hbr, hbrOld;
	hpen = (HPEN) CreatePen(PS_SOLID, size, rgb);
	hpenOld = (HPEN) SelectObject(hDC, hpen);
	hbr = (HBRUSH) GetStockObject(NULL_BRUSH);
	hbrOld = (HBRUSH) SelectObject(hDC, hbr);
	Rectangle(hDC, rc.left, rc.top, rc.right, rc.bottom);
	SelectObject(hDC, hpenOld);
	SelectObject(hDC, hbrOld);
	DeleteObject(hpen);
}// Draw_RectColor

// }bv\pEBhE̍쐬
void CreateMapWindow(HWND hParent)
{
	WNDCLASSEX	wc;
	HWND		hMap;
	HINSTANCE	hInst = GetModuleHandle(NULL);
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC) ProcMap;
	wc.hInstance		= hInst;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= CLASS_MAP;
	RegisterClassEx(&wc);
	
	hMap = CreateWindowEx(WS_EX_TOPMOST, 
				CLASS_MAP,
				"",
				g_dwStyleMap,
				0, 0, 0, 0,
				NULL,
				NULL,
				hInst,
				NULL);
}// CreateMapWindow

// }bv\pEBhETCY̐ݒ
void Resize_MapWin(HWND hDlg)
{
	RECT rc;
	GetWindowRect(hDlg, &rc);
	RECT rcMap = {0, 0, MAP_WIDTH, MAP_HEIGHT};
	AdjustWindowRectEx(&rcMap, g_dwStyleMap, FALSE, NULL);
	MoveWindow(g_hMap, rc.right, rc.top, rcMap.right - rcMap.left, rcMap.bottom - rcMap.top, TRUE);
	InvalidateRect(g_hMap, NULL, FALSE);
}// Resize_MapWin

//	}bvf[^ǂݍ
bool Load_MapData_Bin(char *filename)
{
	// }bvf[^t@CI[v
	FILE *fp = fopen(filename,"rb");
	
	// t@CI[vɐƂ̂ݏ
	if (fp != NULL) {
		// WAcW̓ǂݍ
		gMapSizeX  = fgetc(fp);
		gMapSizeX |= fgetc(fp) << 8;
		gMapSizeX |= fgetc(fp) << 16;
		gMapSizeX |= fgetc(fp) << 24;
		
		gMapSizeY  = fgetc(fp);
		gMapSizeY |= fgetc(fp) << 8;
		gMapSizeY |= fgetc(fp) << 16;
		gMapSizeY |= fgetc(fp) << 24;
		
		// }bvf[^zm
		int i;
		int size = sizeof(unsigned long) * gMapSizeX * gMapSizeY;
		SAFE_FREE(gMapData);
		gMapData = (unsigned long *)malloc(size);
		ZeroMemory(gMapData, size);
		
		// zɊi[
		unsigned char *p = (unsigned char *)gMapData;
		
		for (i = 0; i < size; i++) {
			if (feof(fp)){
				SAFE_FREE(gMapData);
				fclose(fp);
				return false;
			}
			*p = fgetc(fp);
			p++;
		}
		
		//t@CN[Y
		fclose(fp);
		
		if(IsWindow(g_hMap)){
			Set_Scroll_nMax(g_hMap, gMapSizeX * CHIP_SIZE, gMapSizeY * CHIP_SIZE);
		}
		return true;
	}
	return false;
}// Load_MapData_Bin

// }bv`bvZbgǂݍ
// filename	: [IN] t@C
// index	: [IN] 0:wi`bvA1:C[`bv
void Load_Mapchip(char *filename, int index)
{
	if(filename){
		if(index < 0)
			index = 0;
		else if(index > 1)
			index = 1;
		DELGDI(g_map[index].hBmp);
		ZeroMemory(&g_map[index], sizeof(g_map[index]));
		g_map[index].hBmp = (HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, 
									LR_LOADFROMFILE | LR_CREATEDIBSECTION);
		BITMAP  bmp;
		GetObject(g_map[index].hBmp, sizeof(bmp), &bmp);
		g_map[index].width = bmp.bmWidth;
		g_map[index].height = bmp.bmHeight;
	}
}// Load_Mapchip

// L`bv rbg}bv nh擾
// filename		: [IN]	t@C
// x, y			: [IN]	ǂݍ݋`iWj
// width		: [IN]	ǂݍ݋`ij
// height		: [IN]	ǂݍ݋`ij
// flag_alpha	: [IN]	`tOi0:s, 1:Z, 2:x񂠂j
// flag_colorkey: [IN]	J[L[tOifalse:Ȃ, true:j
// colorkey		: [IN]	J[L[
// ߂l	:		󂯎rbg}bv nh
HBITMAP Load_Charachip(char *filename, int x, int y, int width, int height, int flag_alpha, bool flag_colorkey, COLOR colorkey)
{
	BITMAP	bmp;
	HBITMAP	hBmp,hBmpRet;
	DWORD	*pBits = NULL;
	
	hBmp = (HBITMAP) LoadImage(NULL, filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
    if(!hBmp) return NULL;
	
    GetObject(hBmp, sizeof(bmp), &bmp);
    
	if(width <= 0)	width = bmp.bmWidth;
	if(height <= 0)	height = bmp.bmHeight;
	
	BITMAPINFO	bi;
	ZeroMemory(&bi, sizeof(bi));
	bi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= width;
	bi.bmiHeader.biHeight		= height;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount		= 32;
	bi.bmiHeader.biCompression	= BI_RGB;
	
	hBmpRet = (HBITMAP) CreateDIBSection(NULL, &bi, DIB_RGB_COLORS, (VOID**) &pBits, NULL, 0);
	
	BLENDFUNCTION bf;
	bf.BlendOp = AC_SRC_OVER;
	bf.BlendFlags = 0;
	bf.SourceConstantAlpha = 255;
	bf.AlphaFormat = AC_SRC_NO_PREMULT_ALPHA;
	
	HDC     hDCcp1,hDCcp2;
	HBITMAP hBmpPre1,hBmpPre2;
	
	hDCcp1 = CreateCompatibleDC(NULL);
	hDCcp2 = CreateCompatibleDC(NULL);
	hBmpPre1 = (HBITMAP)SelectObject(hDCcp1, hBmpRet);
    hBmpPre2 = (HBITMAP)SelectObject(hDCcp2, hBmp);
	
	if(flag_alpha == 2)
		AlphaBlend(hDCcp1, 0, 0, width, height, hDCcp2, x, y, width, height, bf);
	else
		BitBlt(hDCcp1, 0, 0, width, height, hDCcp2, x, y, SRCCOPY);
	
	if(flag_alpha != 2){
		DWORD dwColorkey = (BYTE)(colorkey.red) << 16 | (BYTE)(colorkey.green) << 8 | (BYTE)(colorkey.blue);
		for(int i=0; i<width * height; i++){	// 32bpp ͕K 4byte EɂȂĂ
			if(!flag_colorkey){
				*pBits |= 0xff000000;
			}
			else{
				if(*pBits != dwColorkey)
					*pBits |= 0xff000000;
				else
					*pBits = 0;
			}
			pBits ++;
		}
	}
	
	SelectObject(hDCcp1, hBmpPre1);
	SelectObject(hDCcp2, hBmpPre2);
	DeleteDC(hDCcp1);
	DeleteDC(hDCcp2);
	DeleteObject(hBmp);
	
	return hBmpRet;
}// Load_Charachip

#endif